using System;
using System.Runtime.Serialization;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationFITR2022
{
    /// <summary>
    /// FITR
    /// </summary>
    [DataContract(Name = "FITR", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class FITR
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public RP RP { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public INT INT { get; set; }
    }

    /// <summary>
    /// Amendment Details
    /// </summary>
    [DataContract(Name = "AmendmentDetails", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class AmendmentDetails
    {

        /// <summary>
        /// Amendment indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool I { get; set; }

        /// <summary>
        /// Amendment sequence number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? AmendmentSequenceN { get; set; }

        /// <summary>
        /// Amendment reason
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string AmendmentReasonT { get; set; }

        /// <summary>
        /// Amendment type code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string AmendmentTypeC { get; set; }
    }

    /// <summary>
    /// Current Postal Address
    /// </summary>
    [DataContract(Name = "CurrentPostalAddress", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class CurrentPostalAddress
    {

        /// <summary>
        /// Current postal address of superannuation fund or trust - Street name and number line 1
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AddressDetailsLine1T { get; set; }

        /// <summary>
        /// Current postal address of superannuation fund or trust - Street name and number line 2
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string AddressDetailsLine2T { get; set; }

        /// <summary>
        /// Current postal address of superannuation fund or trust - Suburb/Town
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string AddressDetailsLocalityNameT { get; set; }

        /// <summary>
        /// Current postal address of superannuation fund or trust - Postcode
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string AddressDetailsPostcodeT { get; set; }

        /// <summary>
        /// Current postal address of superannuation fund or trust - State
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string AddressDetailsStateOrTerritoryC { get; set; }

        /// <summary>
        /// Current postal address of superannuation fund or trust - Country code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string AddressDetailsCountryC { get; set; }
    }

    /// <summary>
    /// Trustee Details
    /// </summary>
    [DataContract(Name = "TrusteeDetails", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class TrusteeDetails
    {

        /// <summary>
        /// Name of non-individual trustee (if applicable)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        /// <summary>
        /// Australian Business Number (ABN) of non-individual trustee (if applicable)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string AustralianBusinessNumberId { get; set; }
    }

    /// <summary>
    /// Electronic fund transfer (EFT)
    /// </summary>
    [DataContract(Name = "ElectronicFundTransfer", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class ElectronicFundTransfer
    {

        /// <summary>
        /// Bank State Branch (BSB) number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string FinancialInstitutionAccountBankStateBranchN { get; set; }

        /// <summary>
        /// Account number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string FinancialInstitutionAccountFinancialInstitutionAccountN { get; set; }

        /// <summary>
        /// Account name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string FinancialInstitutionAccountFinancialInstitutionAccountNameT { get; set; }
    }

    /// <summary>
    /// Status Of Fund Or Trust
    /// </summary>
    [DataContract(Name = "StatusOfFundOrTrust", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class StatusOfFundOrTrust
    {

        /// <summary>
        /// Type of fund or trust at balance date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string PartyTypeC { get; set; }

        /// <summary>
        /// Is the complying superannuation fund an Australian superannuation fund?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public bool SuperannuationFundDetailsAustralianSuperannuationFundStatusI { get; set; }

        /// <summary>
        /// Fund benefit structure
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string SuperannuationFundDetailsFundBenefitStructureC { get; set; }

        /// <summary>
        /// Number of members of the superannuation fund/trust
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? OrganisationControlRegisteredMemberCt { get; set; }

        /// <summary>
        /// The date the superannuation fund was established
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public DateTime OrganisationDetailsEstablishmentD { get; set; }

        /// <summary>
        /// Significant global entity
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public bool? OrganisationDetailsSignificantGlobalEntityStatusI { get; set; }

        /// <summary>
        /// Country-by-country reporting entity
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public bool? InternationalDealingsCountryByCountryReportingEntityStatusI { get; set; }

        /// <summary>
        /// Was the fund wound up during the year?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public bool OrganisationDetailsOperationCeaseI { get; set; }

        /// <summary>
        /// The date the superannuation fund ceased operations if it was wound up during the year
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public DateTime? OrganisationDetailsOrganisationActivityStatusEndD { get; set; }
    }
    
    [CollectionDataContract(Name = "CapitalGainsTaxExemptionOrRolloverAppliedCCollection", Namespace = "http://www.sbr.gov.au/ato/fitr", ItemName="CapitalGainsTaxExemptionOrRolloverAppliedC")]
    public class CapitalGainsTaxExemptionOrRolloverAppliedCCollection: List<string> {}

    /// <summary>
    /// Income
    /// </summary>
    [DataContract(Name = "Income", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class Income
    {

        /// <summary>
        /// Did you have a capital gains tax (CGT) event during the income year?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool CapitalGainsTaxEventI { get; set; }

        /// <summary>
        /// Have you applied an exemption or rollover?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public bool? CapitalGainsTaxExemptionOrRolloverAppliedI { get; set; }

        /// <summary>
        /// Exemption or rollover applied - Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public CapitalGainsTaxExemptionOrRolloverAppliedCCollection CapitalGainsTaxExemptionOrRolloverAppliedCCollection { get; set; }

        /// <summary>
        /// Net capital gain
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? CapitalGainsNetA { get; set; }

        /// <summary>
        /// Gross rent and other leasing and hiring income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? RentLeasingHiringGrossA { get; set; }

        /// <summary>
        /// Gross interest
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? InterestGrossA { get; set; }

        /// <summary>
        /// Forestry managed investment scheme income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal? ForestryManagedInvestmentSchemeA { get; set; }

        /// <summary>
        /// Gross foreign income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public decimal? GrossA { get; set; }

        /// <summary>
        /// Net foreign income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public decimal? NetA { get; set; }

        /// <summary>
        /// Australian franking credits from a New Zealand company
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public decimal? TaxFrankingCreditsReceivedFromNewZealandCompaniesA { get; set; }

        /// <summary>
        /// Transferred from foreign superannuation funds
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 11)]
        public decimal? EquityInternationalDealingsForeignFundTransfersA { get; set; }

        /// <summary>
        /// Number of transfers received from foreign funds for the current income year
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 12)]
        public decimal? InternationalDealingsForeignFundTransfersCt { get; set; }

        /// <summary>
        /// Gross payments made to the fund that were subject to withholding where an Australian Business Number (ABN) was not quoted
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 13)]
        public decimal? RemunerationABNNotQuotedPaymentGrossA { get; set; }

        /// <summary>
        /// Gross distribution from partnerships
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 14)]
        public decimal? PartnershipDistributionGrossA { get; set; }

        /// <summary>
        /// Dividends - Unfranked amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 15)]
        public decimal? DividendsUnfrankedA { get; set; }

        /// <summary>
        /// Dividends - Franked amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 16)]
        public decimal? DividendsFrankedA { get; set; }

        /// <summary>
        /// Dividends - Franking credit
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 17)]
        public decimal? TaxFrankingCreditsA { get; set; }

        /// <summary>
        /// Trust distributions - Income - Unfranked amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 18)]
        public decimal? TrustDistributionUnfrankedA { get; set; }

        /// <summary>
        /// Trust distributions - Income - Franked amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 19)]
        public decimal? TrustDistributionFrankedA { get; set; }

        /// <summary>
        /// Trust distributions - Income - Franking credits
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 20)]
        public decimal? TaxFrankingCreditsFrankingCreditShareReceivedIndirectlyA { get; set; }

        /// <summary>
        /// Trust distributions - Income - Other amounts
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 21)]
        public decimal? TrustDistributionOtherA { get; set; }

        /// <summary>
        /// Assessable employer contributions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 22)]
        public decimal? SuperannuationContributionEmployerAssessableA { get; set; }

        /// <summary>
        /// Assessable personal contributions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 23)]
        public decimal? SuperannuationContributionPersonalAssessableA { get; set; }

        /// <summary>
        /// No-TFN-quoted contributions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 24)]
        public decimal SuperannuationContributionEmployerContributionsTaxFileNumberNotQuotedA { get; set; }

        /// <summary>
        /// Contributions excluded by trustee that contribute to the calculation of assessable contributions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 25)]
        public decimal? SuperannuationContributionContributionsExcludedByTrusteeA { get; set; }

        /// <summary>
        /// Pre-1 July 1988 funding credits amount that contribute to the calculation of assessable contributions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 26)]
        public decimal? SuperannuationContributionReducedContributionsA { get; set; }

        /// <summary>
        /// Transfer of liability to life insurance company (LIC) or pooled superannuation trust (PST)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 27)]
        public decimal? SuperannuationContributionLiabilityTransferToLifeInsuranceCompanyOrPooledSuperannuationTrustAssessableA { get; set; }

        /// <summary>
        /// Foreign exchange gains
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 28)]
        public decimal? ForeignExchangeGainsA { get; set; }

        /// <summary>
        /// Other assessable income received
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 29)]
        public decimal? OtherA { get; set; }

        /// <summary>
        /// Other assessable income received - Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 30)]
        public string OtherC { get; set; }

        /// <summary>
        /// Assessable income due to a change in tax status of the fund
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 31)]
        public decimal? AssessableIncomeDueToFundTaxStatusChangeA { get; set; }

        /// <summary>
        /// Net amount of non-arm's length income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 32)]
        public decimal? NonArmsLengthOtherNetA { get; set; }

        /// <summary>
        /// Exempt current pension income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 33)]
        public decimal? TaxConcessionPensionIncomeExemptDeductionA { get; set; }
    }

    /// <summary>
    /// Deductions
    /// </summary>
    [DataContract(Name = "Deductions", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class Deductions
    {

        /// <summary>
        /// Interest expenses within Australia
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? InterestExpensesAustraliaA { get; set; }

        /// <summary>
        /// Interest expenses overseas
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? InterestExpensesOverseasA { get; set; }

        /// <summary>
        /// Total salary and wage expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? RemunerationWagesandSalariesPaymentsA { get; set; }

        /// <summary>
        /// Capital works deductions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? ExpenseCapitalWorksDeductionA { get; set; }

        /// <summary>
        /// Deduction for decline in value of depreciating assets
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? ExpenseDepreciationAllowableDeductionA { get; set; }

        /// <summary>
        /// Death or disability premiums
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? ExpensePremiumsDeathOrDisabilityA { get; set; }

        /// <summary>
        /// Investment expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal? ExpenseInvestmentA { get; set; }

        /// <summary>
        /// Management expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public decimal? ExpenseOperatingManagementExpenseA { get; set; }

        /// <summary>
        /// Administration expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public decimal? ExpenseOperatingAdministrativeExpenseA { get; set; }

        /// <summary>
        /// Forestry managed investment scheme deduction
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public decimal? ExpenseForestryManagedInvestmentSchemeDeductionA { get; set; }

        /// <summary>
        /// Foreign exchange losses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 11)]
        public decimal? IncomeForeignExchangeLossesA { get; set; }

        /// <summary>
        /// Other deductions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 12)]
        public decimal? ExpenseDeductibleOtherA { get; set; }

        /// <summary>
        /// Other deductions - Code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 13)]
        public string ExpenseDeductibleOtherC { get; set; }

        /// <summary>
        /// Tax losses deducted
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 14)]
        public decimal? IncomeTaxTaxLossesDeductedA { get; set; }

        /// <summary>
        /// Taxable income or loss
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 15)]
        public decimal IncomeTaxableA { get; set; }
    }

    /// <summary>
    /// Income Tax Calculation
    /// </summary>
    [DataContract(Name = "IncomeTaxCalculation", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class IncomeTaxCalculation
    {

        /// <summary>
        /// Tax on taxable income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal TotalTaxOnTaxableIncomeA { get; set; }

        /// <summary>
        /// Tax on no-TFN-quoted contributions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal TFNNotQuotedContributionsTaxA { get; set; }

        /// <summary>
        /// Gross tax
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal TaxableGrossA { get; set; }

        /// <summary>
        /// Foreign income tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? InternationalDealingsTaxOffsetA { get; set; }

        /// <summary>
        /// Rebates and tax offsets
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? TaxOffsetsAndRebatesTotalA { get; set; }

        /// <summary>
        /// Non-refundable non-carry forward tax offsets
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? TaxOffsetNonRefundableNonCarryForwardA { get; set; }

        /// <summary>
        /// Subtotal 1
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal? SubtotalTaxPayableA { get; set; }

        /// <summary>
        /// Early stage venture capital limited partnership (ESVCLP) tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public decimal? ESVCLPTaxOffsetClaimNonRefundableOtherA { get; set; }

        /// <summary>
        /// Early stage venture capital limited partnership (ESVCLP) tax offset carried forward from previous year
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public decimal? PreviousYearESVCLPTaxOffsetClaimNonRefundableOtherA { get; set; }

        /// <summary>
        /// Early stage investor tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public decimal? EarlyStageInvestorTaxOffsetClaimNonRefundableOtherA { get; set; }

        /// <summary>
        /// Early stage investor tax offset carried forward from previous year
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 11)]
        public decimal? PreviousYearEarlyStageInvestorTaxOffsetClaimNonRefundableOtherA { get; set; }

        /// <summary>
        /// Non-refundable carry forward tax offsets
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 12)]
        public decimal? TaxOffsetNonRefundableCarryForwardA { get; set; }

        /// <summary>
        /// Subtotal 2
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 13)]
        public decimal? TaxOffsetCarriedForwardSubTotalA { get; set; }

        /// <summary>
        /// Complying fund's franking credits tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 14)]
        public decimal? FrankingCreditsRefundableA { get; set; }

        /// <summary>
        /// No-TFN tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 15)]
        public decimal? TaxOffsetTFNNotQuotedA { get; set; }

        /// <summary>
        /// National rental affordability scheme tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 16)]
        public decimal? TaxOffsetEntitlementForNationalRentalAffordabilitySchemeA { get; set; }

        /// <summary>
        /// Exploration credit tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 17)]
        public decimal? TaxOffsetExplorationCreditsA { get; set; }

        /// <summary>
        /// Refundable tax offsets
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 18)]
        public decimal? TotalRefundableTaxOffsetsA { get; set; }

        /// <summary>
        /// Tax payable
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 19)]
        public decimal PayableA { get; set; }

        /// <summary>
        /// Section 102AAM interest charge
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 20)]
        public decimal? InternationalDealingsAAMInterestSection102A { get; set; }

        /// <summary>
        /// Credit for interest on early payments - amount of interest
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 21)]
        public decimal? InterestEarlyPaymentCreditA { get; set; }

        /// <summary>
        /// Credit for tax withheld - foreign resident withholding (excluding capital gains)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 22)]
        public decimal? PayAsYouGoWithholdingCreditForAmountsWithheldFromForeignResidentsA { get; set; }

        /// <summary>
        /// Credit for tax withheld - where ABN or TFN not quoted (non-individual)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 23)]
        public decimal? PayAsYouGoWithholdingCreditForAmountsWithheldTFNNotQuotedAndABNNotQuotedA { get; set; }

        /// <summary>
        /// Credit for TFN amounts withheld from payments from closely held trusts
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 24)]
        public decimal? PayAsYouGoWithholdingCreditForTaxWithheldFromCloselyHeldTrustShareReceivedIndirectlyA { get; set; }

        /// <summary>
        /// Credit for interest on no-TFN tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 25)]
        public decimal? TaxOffsetCalculatedInterestTFNNotQuotedA { get; set; }

        /// <summary>
        /// Credit for foreign resident capital gains withholding amounts
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 26)]
        public decimal? PayAsYouGoWithholdingCreditForCapitalGainsWithheldFromForeignResidentsA { get; set; }

        /// <summary>
        /// Eligible credits
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 27)]
        public decimal? DeductionCreditsEligibleTotalA { get; set; }

        /// <summary>
        /// Tax offset refunds (Remainder of refundable tax offsets)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 28)]
        public decimal TotalRemainderOfRefundableTaxOffsetsA { get; set; }

        /// <summary>
        /// PAYG instalments raised
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 29)]
        public decimal? LiabilityInstalmentsTotalA { get; set; }

        /// <summary>
        /// Amount due or refundable
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 30)]
        public decimal PayableOrRefundableTotalA { get; set; }
    }

    /// <summary>
    /// Losses
    /// </summary>
    [DataContract(Name = "Losses", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class Losses
    {

        /// <summary>
        /// Tax losses carried forward to later income years
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? TaxCarriedForwardLaterIncomeYearsTotalA { get; set; }

        /// <summary>
        /// Net capital losses carried forward to later income years
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? CapitalCarriedForwardNetA { get; set; }
    }

    /// <summary>
    /// Transferee
    /// </summary>
    [CollectionDataContract(Name = "TransfereeCollection", Namespace = "http://www.sbr.gov.au/ato/fitr", ItemName="Transferee" )]
    public class TransfereeCollection: List<Transferee> {}

    /// <summary>
    /// Transferee
    /// </summary>
    [DataContract(Name = "Transferee", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class Transferee
    {

        /// <summary>
        /// Transferee name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        /// <summary>
        /// Transferee Australian Business Number (ABN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Transferee amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal IncomeTaxSuperannuationTransferredAssessableA { get; set; }

        /// <summary>
        /// Transferee market value
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal IncomeTaxSuperannuationMarketValueTransferA { get; set; }
    }

    /// <summary>
    /// Transfer Of Liabilities To A Life Insurance Company (LIC) Or Pooled Superannuation Trust (PST)
    /// </summary>
    [DataContract(Name = "TransferOfLiabilities", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class TransferOfLiabilities
    {

        /// <summary>
        /// Has the fund or trust, with consent of the transferee, transferred assessable contributions under section 295-260 to a life insurance company (LIC) or pooled superannuation trust (PST)?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool IncomeTaxSuperannuationTransferredAssessableI { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public TransfereeCollection TransfereeCollection { get; set; }

        /// <summary>
        /// Total market value of investments in any other life insurance company (LIC) or pooled superannuation trust (PST)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? IncomeTaxSuperannuationMarketValueTotalA { get; set; }
    }

    /// <summary>
    /// Taxation Of Financial Arrangements (TOFA)
    /// </summary>
    [DataContract(Name = "TaxationOfFinancialArrangements", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class TaxationOfFinancialArrangements
    {

        /// <summary>
        /// Total Taxation of financial arrangements (TOFA) gains
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? IncomeGainsTotalA { get; set; }

        /// <summary>
        /// Total Taxation of financial arrangements (TOFA) losses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? ExpenseLossesTotalA { get; set; }
    }

    /// <summary>
    /// Overseas Transactions Or Interests And Foreign Source Income
    /// </summary>
    [DataContract(Name = "OverseasTransactions", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class OverseasTransactions
    {

        /// <summary>
        /// International related party dealings and transfer pricing - Did the fund have any transactions or dealings with international related parties, irrespective of whether they were on revenue or capital account?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool InternationalDealingsRelatedPartiesTransactionsI { get; set; }

        /// <summary>
        /// Was the aggregate amount of the transactions or dealings with international related parties (including the value of property transferred or the balance outstanding on any loans) greater than $2 million?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public bool InternationalDealingsRelatedPartiesTransactionsExcessAggregateValueI { get; set; }

        /// <summary>
        /// Overseas interests - Did the fund have an overseas branch or a direct or indirect interest in a foreign trust, foreign company, controlled foreign entity or transferor trust?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public bool InternationalDealingsDirectOrIndirectOverseasInterestI { get; set; }

        /// <summary>
        /// Foreign source income - Was the amount of foreign income tax paid greater than $100000 OR was the amount of assessable foreign income greater than $500000?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public bool InternationalDealingsForeignSourceIncomeExcessAggregateValueI { get; set; }

        /// <summary>
        /// Were any funds or property sent to, or received from, a specified country?
        /// OR
        /// Does the fund have the ability or expectation to control the disposition of any funds, property, assets or investments located in or elsewhere, but controlled or managed from
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public bool InternationalDealingsTransactionsWithTaxHavenCountriesI { get; set; }
    }

    /// <summary>
    /// Other Transactions
    /// </summary>
    [DataContract(Name = "OtherTransactions", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class OtherTransactions
    {

        /// <summary>
        /// Has the actuary's certificate been obtained where exempt current pension income has been claimed?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool? TaxConcessionClaimedExemptCurrentPensionIncomeAndCertificateObtainedI { get; set; }

        /// <summary>
        /// Is a deduction for premiums being claimed for death or disability cover under section 295-465 of the INCOME ASSESSMENT ACT 1997?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public bool IncomeTaxDeductionClaimedDeathOrDisabilityDeductionWhichRequiresCertificateI { get; set; }

        /// <summary>
        /// Has the fund or trust obtained an actuary's certificate where they are claiming a deduction for death or disability cover under section 295-465 of INCOME TAX ASSESSMENT ACT 1997?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public bool? IncomeTaxDeductionClaimedDeathOrDisabilityDeductionCertificateObtainedI { get; set; }

        /// <summary>
        /// Were payments made or benefits transferred to contributing employers and associates that is included in the assessable income of the recipient under section 290-100 of the SPECIALIST LIABILITY RULES to the INCOME TAX ASSESSMENT Act 1997?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public bool SuperannuationPaymentPaymentsToContributingEmployersAndAssociatesI { get; set; }
    }

    /// <summary>
    /// Other Information
    /// </summary>
    [DataContract(Name = "OtherInformation", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class OtherInformation
    {

        /// <summary>
        /// Attributed foreign income in listed countries
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? ListedCountriesIncomeInternationalDealingsAttributedA { get; set; }

        /// <summary>
        /// Attributed foreign income in unlisted countries
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? UnlistedCountriesIncomeInternationalDealingsAttributedA { get; set; }

        /// <summary>
        /// Net assets of the fund available to pay benefits
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? EquityNetAssetsCalculatedA { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public TransferOfLiabilities TransferOfLiabilities { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 5)]
        public TaxationOfFinancialArrangements TaxationOfFinancialArrangements { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 6)]
        public OverseasTransactions OverseasTransactions { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 7)]
        public OtherTransactions OtherTransactions { get; set; }
    }

    /// <summary>
    /// Reporting Party Declaration
    /// </summary>
    [DataContract(Name = "Declaration", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class Declaration
    {

        /// <summary>
        /// Reporting party declaration statement type code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string StatementTypeC { get; set; }

        /// <summary>
        /// Reporting party declaration statement accepted indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public bool StatementAcceptedI { get; set; }

        /// <summary>
        /// Reporting party declaration date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public DateTime SignatureD { get; set; }

        /// <summary>
        /// Reporting party declaration signatory identifier text
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string SignatoryIdentifierT { get; set; }

        /// <summary>
        /// Reporting party declaration signatory name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PersonUnstructuredNameFullNameT { get; set; }
    }

    /// <summary>
    /// Reporting Party Contact Person Details
    /// </summary>
    [DataContract(Name = "ContactPersonDetails", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class ContactPersonDetails
    {

        /// <summary>
        /// Reporting party contact person - Title
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string PersonNameDetailsTitleT { get; set; }

        /// <summary>
        /// Reporting party contact person - Suffix
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string PersonNameDetailsNameSuffixT { get; set; }

        /// <summary>
        /// Reporting party contact person - Family name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string PersonNameDetailsFamilyNameT { get; set; }

        /// <summary>
        /// Reporting party contact person - Given name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string PersonNameDetailsGivenNameT { get; set; }

        /// <summary>
        /// Reporting party contact person - Other given names
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PersonNameDetailsOtherGivenNameT { get; set; }

        /// <summary>
        /// Reporting party contact person - Telephone area code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string ElectronicContactTelephoneAreaC { get; set; }

        /// <summary>
        /// Reporting party contact person - Telephone number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string ElectronicContactTelephoneMinimalN { get; set; }

        /// <summary>
        /// Reporting party contact person - Email address
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public string ElectronicContactElectronicMailAddressT { get; set; }
    }

    /// <summary>
    /// Reporting Party
    /// </summary>
    [DataContract(Name = "RP", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class RP
    {

        /// <summary>
        /// The year the Fund income tax return relates to
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public int TargetFinancialY { get; set; }

        /// <summary>
        /// Reporting period start date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public DateTime PeriodStartD { get; set; }

        /// <summary>
        /// Reporting period end date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public DateTime PeriodEndD { get; set; }

        /// <summary>
        /// Superannuation fund or trust Tax file number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string TaxFileNumberId { get; set; }

        /// <summary>
        /// Name of superannuation fund or trust
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        /// <summary>
        /// Australian Business Number (ABN) of superannuation fund or trust
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string AustralianBusinessNumberId { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 7)]
        public AmendmentDetails AmendmentDetails { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 8)]
        public CurrentPostalAddress CurrentPostalAddress { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 9)]
        public TrusteeDetails TrusteeDetails { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 10)]
        public ElectronicFundTransfer ElectronicFundTransfer { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 11)]
        public StatusOfFundOrTrust StatusOfFundOrTrust { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 12)]
        public Income Income { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 13)]
        public Deductions Deductions { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 14)]
        public IncomeTaxCalculation IncomeTaxCalculation { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 15)]
        public Losses Losses { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 16)]
        public OtherInformation OtherInformation { get; set; }

        /// <summary>
        /// Hours taken to prepare and complete this form
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 17)]
        public decimal? CompletionHoursN { get; set; }

        /// <summary>
        /// Schedule A
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 18)]
        public string RegulatoryDisclosuresGeneralInformationAboutFinancialStatementsT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 19)]
        public Declaration Declaration { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 20)]
        public ContactPersonDetails ContactPersonDetails { get; set; }
    }

    /// <summary>
    /// Intermediary Details
    /// </summary>
    [DataContract(Name = "INT", Namespace = "http://www.sbr.gov.au/ato/fitr")]
    public class INT
    {

        /// <summary>
        /// Intermediary Australian Business Number (ABN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Client's reference
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAgentClientReferenceT { get; set; }

        /// <summary>
        /// Tax agent number (TAN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string TaxAgentNumberId { get; set; }

        /// <summary>
        /// Intermediary contact person name - Title
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string PersonNameDetailsTitleT { get; set; }

        /// <summary>
        /// Intermediary contact person name - Suffix
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PersonNameDetailsNameSuffixT { get; set; }

        /// <summary>
        /// Intermediary contact person name - Family name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string PersonNameDetailsFamilyNameT { get; set; }

        /// <summary>
        /// Intermediary contact person name - Given name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string PersonNameDetailsGivenNameT { get; set; }

        /// <summary>
        /// Intermediary contact person name - Other given names
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public string PersonNameDetailsOtherGivenNameT { get; set; }

        /// <summary>
        /// Intermediary organisation name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        /// <summary>
        /// Intermediary contact telephone - Area code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public string ElectronicContactTelephoneAreaC { get; set; }

        /// <summary>
        /// Intermediary contact telephone - Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 11)]
        public string ElectronicContactTelephoneMinimalN { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 12)]
        public Declaration Declaration { get; set; }
    }
}
 
